#!/usr/bin/env node
const fs = require('fs');
const tool = require('./tools');
const os = require('os');
const path = require('path');
const queryString = require('querystring')

const Desktop = path.join(os.homedir(),'Desktop');
let response = path.join(Desktop,'response')
// console.log(response)
if(!fs.existsSync(response)){
    fs.mkdirSync(response);
}

const express = require('express');    //引入express
const server = express();    //获取server

const ejs = require('ejs');    //引入ejs
const multer = require('multer')    //引入multer
const upload = multer({dest:response})   //确定好下载存储文件

//固定样式三行,配置模板引擎,方便render
server.engine('.html',require('ejs').__express);   
server.set('view engine','html');
server.set('views',path.join(__dirname,'html'))   //html，引入要展示的自己的页面

//中间件(use)
server.use((req,res,next)=>{
    if(req.url.indexOf('.')!= -1){
        res.sendFile(
            path.resolve(queryString.unescape(path.join(response,req.url)))
            // path.join(response,queryString.unescape(req.url))
        )
    }else{
        next();
    }
})

server.get('/',(req,res)=>{    //当服务器收到/的时候做的路由
    res.render('index',{files:fs.readdirSync(response)});    //展示index.html页面，并遍历upload文件夹
})
server.post('/upload',upload.single('file'),(req,res)=>{     //上传文件用post方法 ，file为HTML页面中的name
    fs.rename(
        req.file.path,      //文件的路径
        path.join(response,req.file.originalname),   //定义文件名字（+后缀名）
        (err)=>res.redirect('/')
    );
    // console.log(req)
});
const port=8080;
server.listen(port);
tool.openurl(tool.localaddress()+':'+port);